Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# CollisionEntry Class Reference

Defines a single collision event. More...

Inheritance diagram for CollisionEntry:

List of all members.

## Public Member Functions
bool | collided ()
| returns true if this represents an actual collision as opposed to a potential collision, needed for iterative collision resolution where path of collider changes mid-frame
bool | getAll (NodePath const space, Point3 surface_point, Vec3 surface_normal, Point3 interior_point)
| Simultaneously transforms the surface point, surface normal, and interior point of the collision into the indicated coordinate space.
bool | getAllContactInfo (NodePath const space, Point3 contact_pos, Vec3 contact_normal)
| Simultaneously transforms the contact position and contact normal of the collision into the indicated coordinate space.
Vec3 | getContactNormal (NodePath const space)
| Returns the surface normal of the "into" object at the contact position.
Point3 | getContactPos (NodePath const space)
| Returns the position of the "from" object at the instant that a collision is first detected.
CollisionSolid const | getFrom ()
| Returns the CollisionSolid pointer for the particular solid that triggered this collision.
CollisionNode | getFromNode ()
| Returns the node that contains the CollisionSolid that triggered this collision.
NodePath | getFromNodePath ()
| Returns the NodePath that represents the CollisionNode that contains the CollisionSolid that triggered this collision.
Point3 | getInteriorPoint (NodePath const space)
| Returns the point, within the interior of the "into" object, which represents the depth to which the "from" object has penetrated.
CollisionSolid const | getInto ()
| Returns the CollisionSolid pointer for the particular solid was collided into.
PandaNode | getIntoNode ()
| Returns the node that contains the CollisionSolid that was collided into.
NodePath | getIntoNodePath ()
| Returns the NodePath that represents the specific CollisionNode or GeomNode instance that was collided into.
bool | getRespectPrevTransform ()
| Returns true if the collision was detected by a CollisionTraverser whose respect_prev_transform flag was set true, meaning we should consider motion significant in evaluating collisions.
Vec3 | getSurfaceNormal (NodePath const space)
| Returns the surface normal of the "into" object at the point at which a collision is detected.
Point3 | getSurfacePoint (NodePath const space)
| Returns the point, on the surface of the "into" object, at which a collision is detected.
float | getT ()
| returns time value for this collision relative to other CollisionEntries
bool | hasContactNormal ()
| Returns true if the contact normal has been specified, false otherwise.
bool | hasContactPos ()
| Returns true if the contact position has been specified, false otherwise.
bool | hasInteriorPoint ()
| Returns true if the interior point has been specified, false otherwise.
bool | hasInto ()
| Returns true if the "into" solid is, in fact, a CollisionSolid, and its pointer is known (in which case get_into() may be called to retrieve it).
bool | hasSurfaceNormal ()
| Returns true if the surface normal has been specified, false otherwise.
bool | hasSurfacePoint ()
| Returns true if the surface point has been specified, false otherwise.
| output (ostream out)
| resetCollided ()
| prepare for another collision test
| setContactNormal (Vec3 const normal)
| Stores the surface normal of the "into" object at the contact pos.
| setContactPos (Point3 const pos)
| Stores the position of the "from" object at the instant at which the collision is first detected.
| setInteriorPoint (Point3 const point)
| Stores the point, within the interior of the "into" object, which represents the depth to which the "from" object has penetrated.
| setSurfaceNormal (Vec3 const normal)
| Stores the surface normal of the "into" object at the point of the intersection.
| setSurfacePoint (Point3 const point)
| Stores the point, on the surface of the "into" object, at which a collision is detected.
| setT (float t)
| Sets a time value for this collision relative to other CollisionEntries.
| write (ostream out, int indent_level)
| write (ostream out)
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

Defines a single collision event.

One of these is created for each collision detected by a CollisionTraverser, to be dealt with by the CollisionHandler.

A CollisionEntry provides slots for a number of data values (such as intersection point and normal) that might or might not be known for each collision. It is up to the handler to determine what information is known and to do the right thing with it.

## Member Function Documentation

bool collided | ( |  | ) |

returns true if this represents an actual collision as opposed to a potential collision, needed for iterative collision resolution where path of collider changes mid-frame

bool getAll | ( | NodePath const | space,
|  | Point3 | surface_point,
|  | Vec3 | surface_normal,
|  | Point3 | interior_point
| ) |  |

Simultaneously transforms the surface point, surface normal, and interior point of the collision into the indicated coordinate space.

Returns true if all three properties are available, or false if any one of them is not.

bool getAllContactInfo | ( | NodePath const | space,
|  | Point3 | contact_pos,
|  | Vec3 | contact_normal
| ) |  |

Simultaneously transforms the contact position and contact normal of the collision into the indicated coordinate space.

Returns true if all three properties are available, or false if any one of them is not.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from TypedWritableReferenceCount.

Vec3 getContactNormal | ( | NodePath const | space | ) |

Returns the surface normal of the "into" object at the contact position.

The normal will be converted into whichever coordinate space the caller specifies.

Point3 getContactPos | ( | NodePath const | space | ) |

Returns the position of the "from" object at the instant that a collision is first detected.

The position will be converted into whichever coordinate space the caller specifies.

CollisionSolid const getFrom | ( |  | ) |

Returns the CollisionSolid pointer for the particular solid that triggered this collision.

CollisionNode getFromNode | ( |  | ) |

Returns the node that contains the CollisionSolid that triggered this collision.

This will be a node that has been added to a CollisionTraverser via add_collider().

NodePath getFromNodePath | ( |  | ) |

Returns the NodePath that represents the CollisionNode that contains the CollisionSolid that triggered this collision.

This will be a NodePath that has been added to a CollisionTraverser via add_collider().

Point3 getInteriorPoint | ( | NodePath const | space | ) |

Returns the point, within the interior of the "into" object, which represents the depth to which the "from" object has penetrated.

This can also be described as the intersection point on the surface of the "from" object (which is inside the "into" object). It can be thought of as the deepest point of intersection.

The point will be converted into whichever coordinate space the caller specifies.

CollisionSolid const getInto | ( |  | ) |

Returns the CollisionSolid pointer for the particular solid was collided into.

This pointer might be NULL if the collision was into a piece of visible geometry, instead of a normal CollisionSolid collision; see has_into().

PandaNode getIntoNode | ( |  | ) |

Returns the node that contains the CollisionSolid that was collided into.

This returns a PandaNode pointer instead of something more specific, because it might be either a CollisionNode or a GeomNode.

Also see get_into_node_path().

NodePath getIntoNodePath | ( |  | ) |

Returns the NodePath that represents the specific CollisionNode or GeomNode instance that was collided into.

This is the same node returned by get_into_node(), represented as a NodePath; however, it may be more useful because the NodePath can resolve the particular instance of the node, if there is more than one.

bool getRespectPrevTransform | ( |  | ) |

Returns true if the collision was detected by a CollisionTraverser whose respect_prev_transform flag was set true, meaning we should consider motion significant in evaluating collisions.

Vec3 getSurfaceNormal | ( | NodePath const | space | ) |

Returns the surface normal of the "into" object at the point at which a collision is detected.

The normal will be converted into whichever coordinate space the caller specifies.

Point3 getSurfacePoint | ( | NodePath const | space | ) |

Returns the point, on the surface of the "into" object, at which a collision is detected.

This can be thought of as the first point of intersection. However the contact point is the actual first point of intersection.

The point will be converted into whichever coordinate space the caller specifies.

float getT | ( |  | ) |

returns time value for this collision relative to other CollisionEntries

bool hasContactNormal | ( |  | ) |

Returns true if the contact normal has been specified, false otherwise.

See get_contact_normal(). Some types of collisions may not compute the contact normal.

bool hasContactPos | ( |  | ) |

Returns true if the contact position has been specified, false otherwise.

See get_contact_pos(). Some types of collisions may not compute the contact pos.

bool hasInteriorPoint | ( |  | ) |

Returns true if the interior point has been specified, false otherwise.

See get_interior_point(). Some types of collisions may not compute the interior point.

bool hasInto | ( |  | ) |

Returns true if the "into" solid is, in fact, a CollisionSolid, and its pointer is known (in which case get_into() may be called to retrieve it).

If this returns false, the collision was detected into a GeomNode, and there is no CollisionSolid pointer to be retrieved.

bool hasSurfaceNormal | ( |  | ) |

Returns true if the surface normal has been specified, false otherwise.

See get_surface_normal(). Some types of collisions may not compute the surface normal.

bool hasSurfacePoint | ( |  | ) |

Returns true if the surface point has been specified, false otherwise.

See get_surface_point(). Some types of collisions may not compute the surface point.

output | ( | ostream | out | ) |

resetCollided | ( |  | ) |

prepare for another collision test

setContactNormal | ( | Vec3 const | normal | ) |

Stores the surface normal of the "into" object at the contact pos.

This normal is specified in the coordinate space of the "into" object.

setContactPos | ( | Point3 const | pos | ) |

Stores the position of the "from" object at the instant at which the collision is first detected.

This position is specified in the coordinate space of the "into" object.

setInteriorPoint | ( | Point3 const | point | ) |

Stores the point, within the interior of the "into" object, which represents the depth to which the "from" object has penetrated.

This can also be described as the intersection point on the surface of the "from" object (which is inside the "into" object).

This point is specified in the coordinate space of the "into" object.

setSurfaceNormal | ( | Vec3 const | normal | ) |

Stores the surface normal of the "into" object at the point of the intersection.

This normal is specified in the coordinate space of the "into" object.

setSurfacePoint | ( | Point3 const | point | ) |

Stores the point, on the surface of the "into" object, at which a collision is detected.

This point is specified in the coordinate space of the "into" object.

setT | ( | float | t | ) |

Sets a time value for this collision relative to other CollisionEntries.

write | ( | ostream | out | ) |

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties